"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var common_1 = require('@angular/common');
var ng2_bs3_modal_1 = require('ng2-bs3-modal/ng2-bs3-modal');
var ng2_file_upload_1 = require('ng2-file-upload/ng2-file-upload');
var Ng2FileUploadModal = (function () {
    function Ng2FileUploadModal() {
        this.uploadStatus = new core_1.EventEmitter();
        this.hasBaseDropZoneOver = false;
        this.status = 0;
    }
    Ng2FileUploadModal.prototype.ngOnInit = function () {
        this.title = this.title || 'Upload';
        this.uploader = new ng2_file_upload_1.FileUploader({
            url: this.uploadUrl
        });
        this.uploader.onSuccessItem = this.uploadCallback.bind(this);
        this.uploader.onErrorItem = this.uploadCallback.bind(this);
    };
    Ng2FileUploadModal.prototype.fileOverBase = function (e) {
        this.hasBaseDropZoneOver = e;
    };
    Ng2FileUploadModal.prototype.clear = function () {
        this.uploader.clearQueue();
        this.status = 0;
    };
    Ng2FileUploadModal.prototype.cancel = function () {
        this.uploader.cancelAll();
    };
    Ng2FileUploadModal.prototype.getFile = function () {
        return this.uploader.queue[this.uploader.queue.length - 1];
    };
    Ng2FileUploadModal.prototype.uploadCallback = function (item, response, status, headers) {
        this.status = status;
        this.uploadStatus.emit({ status: status });
    };
    __decorate([
        core_1.Input('title'), 
        __metadata('design:type', String)
    ], Ng2FileUploadModal.prototype, "title", void 0);
    __decorate([
        core_1.Input('uploadUrl'), 
        __metadata('design:type', String)
    ], Ng2FileUploadModal.prototype, "uploadUrl", void 0);
    __decorate([
        core_1.Output('uploadStatus'), 
        __metadata('design:type', Object)
    ], Ng2FileUploadModal.prototype, "uploadStatus", void 0);
    Ng2FileUploadModal = __decorate([
        core_1.Component({
            selector: 'ng2-file-upload-modal',
            directives: [common_1.CORE_DIRECTIVES, common_1.FORM_DIRECTIVES, ng2_bs3_modal_1.MODAL_DIRECTIVES, ng2_file_upload_1.FILE_UPLOAD_DIRECTIVES],
            template: "\n        <a class=\"uploadButton\" (click)=\"modal.open()\">Upload</a>\n        <modal #modal [backdrop]=\"'static'\" (onClose)=\"clear()\" (onDismiss)=\"clear()\">\n            <modal-header>\n                <h4 class=\"modal-title\">{{title}}</h4>\n            </modal-header>\n            <modal-body>\n                <div *ngIf=\"status >= 400\" class=\"alert alert-danger\">\n                    <div class=\"fa fa-times-circle fa-lg alert-icon\"></div>\n                    <div class=\"alert-text\">Could not upload file.</div>\n                </div>\n                <div ng2FileDrop *ngIf=\"status < 400\"\n                    [ngClass]=\"{'nv-file-over': hasBaseDropZoneOver}\"\n                    (fileOver)=\"fileOverBase($event)\"\n                    [uploader]=\"uploader\"\n                    class=\"well my-drop-zone text-center\">\n                        <input type=\"file\" id=\"upload\" name=\"upload\" class=\"inputFile\" ng2FileSelect [uploader]=\"uploader\"/>\n                        <label for=\"upload\"><a>Drag and drop files or click here to select</a></label>\n                </div>\n                <div *ngIf=\"uploader.queue.length > 0 && status < 400\">\n                    <div>{{getFile().file.name}}</div>\n                    <div class=\"progress\" style=\"margin-bottom: 0;\">\n                        <div class=\"progress-bar\" role=\"progressbar\" [ngStyle]=\"{ 'width': getFile().progress + '%' }\"></div>\n                    </div>\n                </div>\n            </modal-body>\n            <modal-footer>\n                <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\" (click)=\"cancel()\" *ngIf=\"status == 0\">Cancel</button>\n                <button type=\"button\" class=\"btn btn-primary\" (click)=\"getFile().upload()\" [disabled]=\"uploader.queue.length == 0 || uploader.isUploading\" *ngIf=\"status == 0\" >Upload</button>\n                <button type=\"button\" class=\"btn btn-primary\" (click)=\"modal.close()\" *ngIf=\"status >= 200\">Close</button>\n            </modal-footer>\n        </modal>\n    ",
            styles: ["\n        .uploadButton:hover {\n            cursor: pointer;\n        }\n\n        .inputFile {\n            width: 0.1px;\n            height: 0.1px;\n            opacity: 0;\n            overflow: hidden;\n            position: absolute;\n            z-index: -1;\n        }\n\n        .inputFile + label:hover {\n            cursor: pointer;\n        }\n\n        .my-drop-zone {\n            border: dashed 2px lightgray;\n        }\n\n        .nv-file-over {\n            border: dashed 2px #e11b22;\n        }\n    "]
        }), 
        __metadata('design:paramtypes', [])
    ], Ng2FileUploadModal);
    return Ng2FileUploadModal;
}());
exports.Ng2FileUploadModal = Ng2FileUploadModal;
